/*
Copyright 2015-2016, Manuel Bichler
WWW: <http://dbai.tuwien.ac.at/proj/lpopt/>

This file is part of lpopt.

lpopt is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

lpopt is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with lpopt.  If not, see <http://www.gnu.org/licenses/>.
*/

#include "StringGenerator.hpp"

using namespace std;

namespace domain
{
  StringGenerator::StringGenerator() : StringGenerator(new string("temp"))
  {
  }
  StringGenerator::StringGenerator(string* baseName) : baseName(baseName), ct(0)
  {
  }
  StringGenerator::~StringGenerator()
  {
    delete baseName;
  }
  
  string* StringGenerator::get()
  {
    string* s = new string(*baseName);
    s->append(to_string(ct));
    ++ct;
    return s;
  }
  string* StringGenerator::previous()
  {
    --ct;
    string* s = get();
    ++ct;
    return s;
  }
  
  
  StringGeneratorGenerator::StringGeneratorGenerator() : StringGeneratorGenerator(new string("temp"))
  {
  }
  StringGeneratorGenerator::StringGeneratorGenerator(string* baseName) : baseName(baseName), ct(0), prev(NULL)
  {
  }
  StringGeneratorGenerator::~StringGeneratorGenerator()
  {
    delete baseName;
  }
  
  StringGenerator* StringGeneratorGenerator::get()
  {
    string* s = new string(*baseName);
    s->append(to_string(ct));
    ++ct;
    prev = new StringGenerator(s);
    return prev;
  }
  
  StringGenerator* StringGeneratorGenerator::previous()
  {
    return prev;
  }


} // namespace domain
